<?php 
/*
Plugin Name: Read More Right Here
Plugin URI: http://www.wooliet.com/wp-plugins/
Description: Allow users to view your entry's &lt;!--more--&gt; content immediately.
Author: William King
Author URI: http://www.condesoftware.com
Version: 1.1.3
*/

// "loading" GIF generated at http://www.ajaxload.info/

function wt_rmrh_oninit()
{
	/*******************************************
	 * 			CUSTOM VALUES
	 * 
	 *
	 *	The following values can be modified to change some of the
	 *	  aspects of the plugin. 
	 *
	 *!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	 *			WARNING WARNING WARNING WARNING
	 *!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	 *
	 *	Any changes to these values will be OVERWRITTEN the
	 *	next time this plugin is updated.  Future version 
	 *  of the plugin might add an options page to store
	 *  such values, but for now this is an attempt to keep
	 *  the plugin from leaving any trace of itself behind
	 *  should you remove it.
	 *  
	 *******************************************/
	
	/**
	 * The name of the image to display while the "Read More" content
	 * 	is loaded. It is assumed this file exists at the root of this
	 * 	plugin's directory.
	 * <br>
	 * @var string
	 * default:  $loadImageName = 'ajax-loader.gif';
	 */
	$loadImageName = 'ajax-loader.gif'; 	// !!! WARNING - If you place a new image in the plugin directory,
											//					a plugin update will DELETE IT.
	
	
	/**
	 * Text used as a replacement for the 'read more' link in the post.
	 * 	Leave as an empty string to prevent any change
	 * <br>
	 * @var string
	 * default:  $moreLinkExpandedText = "";
	 */ 
	$moreLinkText_OnExpand = "";
	
	/**
	 * If true (value == 1), the 'more link' anchor element will be duplicated and moved
	 *   to after the displayed post's content. This is useful if you wish 
	 *   for the reads to be able to collapse the text from the bottom
	 *   of the post (and not just from the default 'more link' location).
	 * <br>
	 * @var int - 1 for 'yes' and 0 for 'no'
	 * default:  $addLinkToEnd_OnExpand = 0;
	 */
	$addLinkToEnd_OnExpand = 0;
	
	
	/**
	 * The speed (in milliseconds) with which the post expands to display
	 *   the new content
	 * <br>
	 * @var int
	 * default:  $animateSpeed = 1000;
	 */
	$animateSpeed = 1000;
	
	/*******************************************
	 * 			END CUSTOM VALUES
	 *******************************************/
	
    if($_POST)
    {
        if($_POST['wt-rmrh-redirect'] == '1')
        {
            query_posts("p=" . $_POST['postid']);
            if(have_posts())
            {
                the_post();
                $spanId = "more-" . $_POST['postid'];
                $content = get_the_content();
                // have to apply any filters; 'get_the_content' does
                // not do this (copied from 'the_content', WP function)
                $content = apply_filters('the_content', $content);
                $content = str_replace(']]>', ']]&gt;', $content);
                // grab only the stuff after 'more'
                $debris = explode("<span id=\"".$spanId."\"></span>", $content);
                echo $debris[1];
                exit;
            }
            else
            {
            	// no post with matching id, return 404
            	header("HTTP/1.0 404 Not Found");
            	exit;
            }
        }
    }
    
    // let's stay out of the admin adrea
    if(!is_admin())
    {
    	// Includes trailing slash
    	$pluginUrl = plugin_dir_url(__FILE__);
        // wt_rmrh.js can be replaced with wt_rmrh-debug.js
        // to debug uncompressed javascript source
        wp_register_script(
			'wt_rmrh', 
            $pluginUrl . "js/wt_rmrh.js",
            array('jquery'));
            
        wp_enqueue_script('wt_rmrh');
        
        $customValues =	
        	array(
        		'pluginUrl' => $pluginUrl,
        		'loadImageName' => $loadImageName,
        		'duplicateLink' => $addLinkToEnd_OnExpand,
        		'animateSpeed' => $animateSpeed
			); // end $customValues array
        
        if(strlen($moreLinkText_OnExpand) > 0)
        	$customValues['expandedText'] = $moreLinkText_OnExpand;
        
        // This injects the defined values into the page header
        // to make available in our javascript.
        wp_localize_script('wt_rmrh', 
        				   'RMRH_VALUES', 
        				   $customValues);
    }            
}

add_action('init', wt_rmrh_oninit);


/**
 * The purpse of this filter is to add a custom class to the
 *   more link that can be used to identify the post ID regardless
 *   of the link structure used. In other words, remove the
 *   reliance on the "#[post-id]" in the link.
 * <br>
 * @param $link
 * @return $link with new class
 */
function wt_rmrh_morelink_filter($link)
{
	global $post;
	
	$target = "class=\"";
	$pos = strpos($link,$target);
	
	$newClass = "rmrh-postId-". $post->ID;

	// the 'class' has been completely removed, add it back
	if($pos === false)
	{
		$target = "<a ";
		$pos = strpos($link,$target);
		$replacement = "class=\"" . $newClass . "\" ";
	}
	else
	{
		$replacement = $newClass . " ";
	}
	

	$at = $pos + strlen($target);
	$result = substr_replace($link, $replacement,$at,0);

	return $result;
}

add_filter('the_content_more_link', wt_rmrh_morelink_filter, 999);


?>
